wf = require"windfield"
require"player"
require"projectile"
gamera = require"gamera"
local sti = require"sti"


function love.load()
  love.window.maximize()
  cam = gamera.new(0,0,3008,3008)
  world =  wf.newWorld(0,0,true)
  world:addCollisionClass('Projectile')
  world:addCollisionClass('Player', {ignores = {"Projectile"}})
  world:addCollisionClass('Target',{ignores = {"Projectile","Player"}})
  world:addCollisionClass('wall')
  wall = world:newRectangleCollider(100,100,1000,10)
  wall2 = world:newRectangleCollider(200,100,10,1000)
  wall3 = world:newRectangleCollider(500,100,10,1000)
  wall:setCollisionClass("wall")
  wall2:setCollisionClass("wall")
  wall3:setCollisionClass("wall")
  wall:setType('static')
  wall2:setType('static')
  wall3:setType('static')
  player:load()
  collision_data = {}
  collision_data.collider = "false"

end


function updateWindow()
  if love.keyboard.isDown("f11") and love.window.getFullscreen() then
    love.window.setFullscreen(false)
  elseif love.keyboard.isDown("f11") and not love.window.getFullscreen() then
    love.window.setFullscreen(true)
  end
  if love.keyboard.isDown("escape") then
    love.window.close()
  end
end


function love.update(dt)
  updateWindow()
  world:update(dt)
  player:update(dt)
  projectiles:update(dt)
end


function love.draw()
  cam:draw(function()
    world:draw()
    player:draw()
      for i,v in ipairs(projectiles) do
        local vx,vy = v:getLinearVelocity()
        love.graphics.print(math.abs(vx),10,i*10)
        love.graphics.print(math.abs(vy),200,i*10)
      end
    love.graphics.print(collision_data.collider,400)
  end)
end
