  player = {}


function player:load()
  player.angle = 0
  player.x = 0
  player.y = 0
  player.vectx = 0
  player.vecty = 0
  player.width = 10
  player.height = 10
  player.collider = world:newRectangleCollider(player.x,player.y,player.width+5,player.height+5)
  player.collider:setObject(player)
  player.collider:setCollisionClass("Player")
  player.collider.friction = 10
  player.collider.speed = 1
  player.collider:setFixedRotation(true)
  player.target = {}
  player.target.x = 0
  player.target.y = 0
  player.target.r = 10
  player.target = world:newCircleCollider(player.target.x,player.target.y,10)
  player.target:setCollisionClass("Target")
end


function player:update(dt)
  player:physicsSync(dt)
  player:move(dt)
  player:updateTarget(dt)
  player:look()
  cam:setPosition(player.x, player.y)
end


function player:look()
  local angle = math.atan2(player.y-player.target.y,player.x-player.target.x)
  player.collider:setAngle(angle)
  return angle
end


function player:updateTarget(dt)

  player.target.x, player.target.y = cam:toWorld(love.mouse.getPosition())
  player.target:setPosition(player.target.x,player.target.y)
end


function love.mousepressed(x, y, button)
   if button == 1 then
      bulx,buly = shootProjectile(player.x+player.width/2,player.y+player.height/2,player.target.x,player.target.y,1000,5)

   elseif button == 2 then
     shootProjectile(player.x+player.width/2,player.y+player.height/2,player.target.x,player.target.y+10,500,love.math.random(1, 10))
     shootProjectile(player.x+player.width/2,player.y+player.height/2,player.target.x,player.target.y-10,500,love.math.random(1, 10))

   end
end


function player:physicsSync(dt) -- syncs the visible square character with it's collider
  local px,py = player.collider:getPosition()
  player.x = px - player.width/2
  player.y = py - player.height/2
  player.vectx = player.vectx * (1 - math.min(dt*player.collider.friction,1))
  player.vecty = player.vecty * (1 - math.min(dt*player.collider.friction,1))
  player.collider:setLinearVelocity(player.vectx*500,player.vecty*500)
end


function player:move(dt)
  --If w is down, vecty is negative elseif s is down, vecty is positive
  if love.keyboard.isDown("w") then
    player.vecty = -1
  elseif love.keyboard.isDown("s") then
    player.vecty = 1
  end
  --same as above but with vectx
  if love.keyboard.isDown("a") then
    player.vectx = -1
  elseif love.keyboard.isDown("d") then
    player.vectx = 1
  end
end


function love.keypressed( key )
   if key == "=" then
    player.collider.friction = player.collider.friction + 1
   elseif key == "-" then
    player.collider.friction = player.collider.friction - 1
   end
end


function player:draw()
  love.graphics.push()
  love.graphics.translate(player.x+player.width/2, player.y+player.height/2)
  love.graphics.push()
  love.graphics.rotate(player:look())
  love.graphics.rectangle("fill", 0-player.width/2, 0-player.height/2, player.width, player.height)
  love.graphics.pop()
  love.graphics.pop()
  love.graphics.origin()
end
