projectiles = {}


function shootProjectile(x,y,targetx,targety,speed,rad,spread)
  bullet = world:newCircleCollider(x,y,rad)  --creates a new circle collider as a bullet
  bullet.speed = speed
  bullet:setCollisionClass("Projectile") --sets the bullet's class
  bullet:setRestitution(1) -- sets the bullet restitution aka its bounciness to max
  local ux, uy = targetx - x, targety - y
  local vx, vy
  local len = math.sqrt(ux*ux + uy*uy)
  if len > 1e-15 then
    -- length is reasonable; divide by length to get a unit vector
    ux = ux / len
    uy = uy / len
    -- now apply spread (the variable 'spread' should probably be at the top)
    local spread = 0-- units of spread per each unit of distance; e.g. 1 means 45° to each side
    -- calculate a horizontal vector with length approximately equal to speed
    vx, vy = speed, speed*(love.math.random()*2*spread-spread)
    -- rotate it to align it to ux, uy
    vx, vy = ux * vx + uy * vy, uy * vx - ux * vy
  else
    -- target extremely close; it's hard to tell the actual direction. Point right in that case.
    vx = speed
    vy = 0
  end
    --Applies the velocity to the bullet
  bullet:setLinearVelocity(vx,vy)
  table.insert(projectiles,bullet)
  return projectiles
end

function projectiles:update(dt)
  projectiles:onCollision("wall",playSound)
end


function projectiles:onCollision(collider,funct)
  for i,v in ipairs(self) do
    if v:enter(collider) then
      funct("hurt.mp3")
    end
  end
end

function playSound(file)
  sound = love.audio.newSource(file, "static")
  love.audio.play(sound)
end
